﻿var MetriloHelper = {
    enableDebug: false,
    Init: function (cc, debug) {
        this.enableDebug = debug;
    },

    _getProductId: function (object) {
        var productid = $(object).data("productid");
        if (productid > 0) {
            return productid;
        }
        var script = $(object).attr("onclick");
        if (script && script.length > 0) {
            //productid = parseInt(script.replace(/[^0-9]/g, ''));
            var numn = script.match(/\d+/g);
            if (numn != null) {
                productid = numn.map(Number)[0];
                if (productid > 0) {
                    return productid;
                }
            }
        }
        return 0;
    },
    Initialization: function () {
        MetriloHelper.ReloadEvents();

        $(document).on("nopAjaxCartProductAddedToCartEvent", function (event) {
            MetriloHelper.AddToCart('addToCart', event.productId, event.quantity);
        });
        //$(document).on("nopAjaxCartButtonsAddedEvent", MetriloHelper.ReloadEvents());
        if (typeof lazyLoadingMetrilo === "function") {
            lazyLoadingMetrilo();
        }
    },
    ReloadEvents: function () {
        //addToCart
        $('.add-to-cart-button, .product-box-add-to-cart-button').each(function () {
            var productid = MetriloHelper._getProductId(this);
            if (productid > 0) {
                $(this).click({ productid: productid }, function (event) {
                    event.preventDefault();
                    MetriloHelper.AddToCart('addToCart', event.data.productid);
                });
            }
        });
        //addToWishlist
        /*$('.add-to-wishlist-button').each(function () {
            var productid = MetriloHelper._getProductId(this);
            if (productid > 0) {
                $(this).click({ productid: productid }, function (event) {
                    event.preventDefault();
                    MetriloHelper.AddToCart('addToWishlist', event.data.productid);
                });
            }
        });*/
        //remove from the cart/wishlist
        $('input[name="updatecart"]').click(function () {
            $('input[name="removefromcart"]:checked').each(function () {
                var cartitemid = $(this).val();
                if (cartitemid > 0) {
                    MetriloHelper.RemoveFromCart(cartitemid);
                }
            });
        });

        //copy from wishlist to cart
        $('input[name="addtocartbutton"]').click(function () {
            $('input[name="addtocart"]:checked').each(function () {
                var cartitemid = $(this).val();
                if (cartitemid > 0) {
                    var products = $.grep(MetriloWishlistProducts, function (e) { return e.cartItemId == cartitemid; });
                    if (products.length > 0) {
                        var quantity = $('input[name="itemquantity' + cartitemid + '"]').val();
                        MetriloHelper.AddToCart('copyToCartFromWishlist', products[0].productId, quantity);
                    }
                }
            });
        });
    },
    AddToCart: function (eventname, productid, quantity) {
        var products = $.grep(MetriloProductDelails, function (e) { return e.productId == productid; });
        if (products.length == 0) {
            products = $.grep(MetriloProductImpressions, function (e) { return e.productId == productid; });
        }
        /*if (products.length == 0) {
            products = $.grep(MetriloWishlistProducts, function (e) { return e.productId == productid; });
        }*/
        if (products.length > 0) {
            /*if (quantity == undefined)
                quantity = $('#addtocart_' + productid + '_EnteredQuantity').val();
            if (quantity == undefined)
                quantity = 1;
            if (eventname == undefined)
                eventname = 'addToCart';
            products[0].quantity = quantity;*/
            this.WriteConsole({ 'AddToCart': [eventname, products[0]] });

            metrilo.event('add_to_cart', products[0]);
        }
    },
    RemoveFromCart: function (cartitemid, quantity) {
        var eventName = 'remove_from_cart';
        var products = $.grep(MetriloCartProducts, function (e) { return e.cartItemId == cartitemid; });
        /*if (products.length == 0) {
            eventName = 'remove_from_wishList';
            products = $.grep(MetriloWishlistProducts, function (e) { return e.cartItemId == cartitemid; });
        }*/
        if (products.length > 0) {
            /*if (quantity == undefined)
                quantity = $('input[name="itemquantity' + cartitemid + '"]').val();
            if (quantity == undefined)
                quantity = 1;
            products[0].quantity = quantity;
            */
            this.WriteConsole({ 'remove_from_cart': products[0] });

            var productParams = { id: products[0].id };
            metrilo.event(eventName, productParams);
        }
    },
    WriteConsole: function (obj) {
        if (this.enableDebug) {
            str = JSON.stringify(obj);
            //str = JSON.stringify(obj, null, 4); // (Optional) beautiful indented output.
            console.log(str); // Logs output to dev tools console.
        }
    },
};
